﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Net;
using System.Net.Sockets;
using System.IO;

namespace FTP_SERVIDOR_2020
{
    class ftpservidor
    {
        public static string caminhoRecepcao = @"D:\Sergio\arquivos\";
        static IPEndPoint ipEnd_Servidor;
        static Socket socket_Servidor;
        public static string mensagemServidor = "Serviço Encerrado !!";

        public static void IniciaServidor(string IP_Servidor, int Porta)
        {
            try
            {
                ipEnd_Servidor = new IPEndPoint(IPAddress.Parse(IP_Servidor), Porta);
                socket_Servidor = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.IP);
                socket_Servidor.Bind(ipEnd_Servidor);
                mensagemServidor = "Servidor iniciado...";
            }
            catch (Exception err)
            {
                mensagemServidor = err.Message + "\nServidor não iniciado...";
            }

            try
            {
                socket_Servidor.Listen(100);
                mensagemServidor = "Servidor pronto pra receber o arquivo...";
                Socket clienteSock = socket_Servidor.Accept();
                clienteSock.ReceiveBufferSize = 16384;

                byte[] dadosCliente = new byte[5000 * 1024];

                int tamanhoBytesRecebidos = clienteSock.Receive(dadosCliente, dadosCliente.Length, 0);
                int tamanhoNomeArquivo = BitConverter.ToInt32(dadosCliente, 0);
                string nomeArquivo = Encoding.UTF8.GetString(dadosCliente, 4,tamanhoNomeArquivo);

                BinaryWriter bWrite = new BinaryWriter(File.Open(caminhoRecepcao + nomeArquivo, FileMode.Append));
                bWrite.Write(dadosCliente, 4 + tamanhoNomeArquivo, tamanhoBytesRecebidos - 4 - tamanhoNomeArquivo);
               
                while (tamanhoBytesRecebidos > 0)
                {
                    tamanhoBytesRecebidos = clienteSock.Receive(dadosCliente, dadosCliente.Length, 0);
                    if (tamanhoBytesRecebidos == 0)
                        bWrite.Close();
                    else
                        bWrite.Write(dadosCliente, 0, tamanhoBytesRecebidos);
                }
                bWrite.Close();
                clienteSock.Close();
                mensagemServidor = "Arquivo " + nomeArquivo + " recebido com sucesso.\nForam recebidos " + (tamanhoBytesRecebidos - 4 - tamanhoNomeArquivo) + " bytes.\nServidor encerrado.";

            }
            catch (Exception err)
            {
                mensagemServidor = err.Message + "\nArquivo não recebido";
            }
        }
    }
}
