﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Net;
using System.Net.Sockets;
using System.IO;

namespace clienteftp22
{
    internal class FTPCliente
    {
        public static string mensagemCliente = "em espera...";
        public static string IP;
        public static int Porta;

        public static void EnviarArquivo(string nomeArquivo)
        {
            try
            {
                IPEndPoint ipEnd_cliente = new IPEndPoint(IPAddress.Parse(IP), Porta);
                Socket clienteSocket = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.IP);
                string caminho = "";
                nomeArquivo = nomeArquivo.Replace("\\", "/");

                while (nomeArquivo.IndexOf("/") > -1)
                {
                    caminho += nomeArquivo.Substring(0, nomeArquivo.IndexOf("/") + 1);
                    nomeArquivo = nomeArquivo.Substring(nomeArquivo.IndexOf("/") + 1);
                }

                byte[] nomeArquivoByte = Encoding.UTF8.GetBytes(nomeArquivo);
                if(nomeArquivoByte.Length > 5000 * 1024)
                {
                    mensagemCliente = "O arquivo deve ter menos de 5Mb";
                    return;
                }

                string caminhoCompleto = caminho + nomeArquivo;
                byte[] fileData = File.ReadAllBytes(caminhoCompleto);
                byte[] clienteData = new byte[4 + nomeArquivoByte.Length + fileData.Length];
                byte[] nomeArquivoLen = BitConverter.GetBytes(nomeArquivoByte.Length);

                nomeArquivoLen.CopyTo(clienteData, 0);
                nomeArquivoByte.CopyTo(clienteData, 4);
                fileData.CopyTo(clienteData, 4 + nomeArquivoByte.Length);
                clienteSocket.Connect(ipEnd_cliente);
                clienteSocket.Send(clienteData, 0, clienteData.Length, 0);
                clienteSocket.Close();
                mensagemCliente = "Arquivo " + caminhoCompleto + " transferido.";
            }
            catch (Exception ex)
            {
                mensagemCliente = ex.Message + " \nArquivo não transmitido.";
            }
        }
    }
}
