﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace clienteftp22
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void btn_arquivo_Click(object sender, EventArgs e)
        {
            if(openFileDialog1.ShowDialog() == DialogResult.OK)
                txt_arquivo.Text = openFileDialog1.FileName;
        }

        private void btn_sair_Click(object sender, EventArgs e)
        {
            Environment.Exit(0);
        }

        private void btn_definir_Click(object sender, EventArgs e)
        {
            FTPCliente.IP = txt_ip.Text;
            FTPCliente.Porta = int.Parse(txt_porta.Text);
            
        }

        private void btn_trasnfere_Click(object sender, EventArgs e)
        {
            try
            {
                FTPCliente.EnviarArquivo(txt_arquivo.Text);
                lsb_msgCliente.Items.Add(FTPCliente.mensagemCliente);
            }
            catch(Exception ex)
            {
                MessageBox.Show(ex.Message, "Erro", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }
    }
}
